<?php

defined('BASEPATH') OR exit('No direct script access allowed');

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
require APPPATH . '/libraries/REST_Controller.php';

/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          Hector Luna
 * @license         MIT
 * @link            https://github.com/chriskacerguis/codeigniter-restserver
 */
class Cvweb extends REST_Controller {

	function __construct() {
		header('Access-Control-Allow-Origin: *');
		header("Access-Control-Allow-Headers: Content-Type, Cache-Control");
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT");
		$method = $_SERVER['REQUEST_METHOD'];
		if($method == "OPTIONS") {
				die();
		}

		parent::__construct();
		//$this->load->model('Md_facebook');
		$this->load->model('Md_bot');
	}

	public function welcome_get() {

			$account = $this->Md_bot->getUser($this->get('auth'));
			$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

			if( isset( $mensajes[0]['bienvenida'] ) && $mensajes[0]['bienvenida'] != '' ) {
				$data = $mensajes[0]['bienvenida'];
			} else {
				$data = '';
			}

			$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);
	}

	public function live_put() {

			$post = $this->put();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$device = $cleanPost['usr_dev'];

			$data = [];
			$data['mensaje'] = '';
			$data['bot'] = '';

			if ( isset($account[0]) ) {

				$return = $this->Md_bot->getLive($account[0]['id'], $ip, $device);

				if($return) {
					$data['bot'] = $return[0]['bot'];
					$return2 = $this->Md_bot->putLive($return, $account[0]['id']);

					if(!empty($return2)) {
						foreach ($return2 as $value) {
							$name = $this->Md_bot->getUsername($value['user_id']);
							$data['mensaje'] .=  '<div style="width:100%;float:left;">';
							$data['mensaje'] .= '<div class="fogata-bot-response">'.base64_decode($value['message']).'</div>';
							$data['mensaje'] .= '</div>';
							if($name[0]['name'] != '') {
								$data['mensaje'] .=  '<div style="width:100%;float:left;">';
								$data['mensaje'] .= '<div style="font-size: 9px"><b>Agent: </b>'.$name[0]['name'].'</div>';
								$data['mensaje'] .= '</div>';
							}

						}
					}
				}

				$data = json_encode($data);

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);

			} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);
	}

	public function live_post() {

			$post = $this->post();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$device = $cleanPost['usr_dev'];

			$data = [];
			$data['mensaje'] = '';
			$data['bot'] = '';

			if ( isset($account[0]) ) {

				$return = $this->Md_bot->getLive($account[0]['id'], $ip, $device);

				if($return) {
					$data['bot'] = $return[0]['bot'];
					$return2 = $this->Md_bot->putLive($return, $account[0]['id']);

					if(!empty($return2)) {
						foreach ($return2 as $value) {
							$name = $this->Md_bot->getUsername($value['user_id']);
							$data['mensaje'] .=  '<div style="width:100%;float:left;">';
							$data['mensaje'] .= '<div class="fogata-bot-response">'.base64_decode($value['message']).'</div>';
							$data['mensaje'] .= '</div>';
							if($name[0]['name'] != '') {
								$data['mensaje'] .=  '<div style="width:100%;float:left;">';
								$data['mensaje'] .= '<div style="font-size: 9px"><b>Agent: </b>'.$name[0]['name'].'</div>';
								$data['mensaje'] .= '</div>';
							}

						}
					}
				}

				$data = json_encode($data);

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);

			} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);
	}

	public function user_put() {


			$post = $this->put();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$name = $cleanPost['name'];
			$email = $cleanPost['email'];
			$phone = $cleanPost['phone'];
			$device = $cleanPost['usr_dev'];

			if ( isset($account[0]) ) {

				$return = $this->Md_bot->putUser($account[0]['id'], $ip, $name, $email, $phone, $device);

				if($return)

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $return], REST_Controller::HTTP_OK);

				else

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $return], REST_Controller::HTTP_OK);

			} else $this->set_response(['status' => FALSE, 'codigo' => 1, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);
	}

	public function user_post() {


			$post = $this->post();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$name = $cleanPost['name'];
			$email = $cleanPost['email'];
			$phone = $cleanPost['phone'];
			$device = $cleanPost['usr_dev'];

			if ( isset($account[0]) ) {

				$return = $this->Md_bot->putUser($account[0]['id'], $ip, $name, $email, $phone, $device);

				if($return)

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $return], REST_Controller::HTTP_OK);

				else

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $return], REST_Controller::HTTP_OK);

			} else $this->set_response(['status' => FALSE, 'codigo' => 1, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);
	}

	public function newchat_put() {

			$post = $this->put();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$word = $cleanPost['msg'];
			$type = $cleanPost['type'];
			$key = $cleanPost['bots_key_id'];
			$device = $cleanPost['usr_dev'];
			$msg = FALSE;
			$data = [];
			$data['mensaje'] = '';
			$data['botones'] = '';
			$keyEncId = $cleanPost['keyenc_id'];
			$keyId = $cleanPost['keyenc'];

//error_log( 'llega mierda ' . $word);
			function getEncodeUrl($text) {
		 		$retu =  base64_decode($text);
		 		$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
				$replace = preg_replace_callback($url, function($matches) {
						if( strlen($matches[0]) > 20 ) {
							$urlTxt = substr($matches[0], 0, 20).'...';
						} else {
							$urlTxt = $matches[0];
						}
				    return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
				}, $retu);
		 		return $replace;
		 	}

			function getEncodeUrl2($text) {
				$retu =  $text;
				$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
				$replace = preg_replace_callback($url, function($matches) {
						if( strlen($matches[0]) > 20 ) {
							$urlTxt = substr($matches[0], 0, 20).'...';
						} else {
							$urlTxt = $matches[0];
						}
				    return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
				}, $retu);
		 		return $replace;
			}

			function normaliza ($cadena){
				$originales =  'ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûýýþÿŔŕ?¿';
				$modificadas = 'aaaaaaaceeeeiiiidnoooooouuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyRr?¿';
				$cadena = utf8_decode($cadena);
				$cadena = strtr($cadena, utf8_decode($originales), $modificadas);
				$cadena = strtolower($cadena);
				return utf8_encode($cadena);
			}



			if ( isset($account[0]) ) {

				$cycles = $this->Md_bot->getCycle($ip, $device, $account[0]['id']);
				//aki
				$typeA = 0;
				if($cycles){
					////error_log( 'llega mierda ' . $type);
					$respuesta = $this->Md_bot->getEncResp( $cycles );
					//$respuestaID = $this->Md_bot->getEncRespId( $keyID );
					$data['mensaje'] =  getEncodeUrl2( $respuesta[0]['text'] );
					//$msg = $respuestaID[0]['button'];
					$buttons = $this->Md_bot->getBotonesEnc( $cycles );
					foreach ($buttons as $btn) {
						$data['botones'] .= '<div data-id="'.$respuesta[0]['id'].'" class="fogata-encuesta-callback">'.$btn['button'].'</div>';
					};

					$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $keyId, $keyEncId, $device, $word, $typeA);
				//	$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], $key, 0, $device, $word, $typeA);
					//$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $key, 0, $device, $word);

					$data = json_encode($data);
					$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);

				} else{

				$keys = $this->Md_bot->getKeys($account[0]['id']);

				if ($type == 1 && count($keys) > 0) {

			        $mensaje = strtolower($word);
			        $mensaje = urldecode($mensaje);
			        $mensaje = normaliza($mensaje);

			        //$hilos = json_decode($keys);

							foreach ($keys as $value) {
								$exp[ $value['id'] ]['id']= $value['id'];
								$exp[ $value['id'] ]['key']= $value['key_group'];
								$exp[ $value['id'] ]['mensaje']= $value['mensaje'];
								$exp[ $value['id'] ]['mail_alert']= $value['mail_alert'];
								$chk[ $value['id'] ] = strtolower($value['key']);
			          //echo normaliza(strtolower($value->key)).'  //  ';
							}

							$found = FALSE;
							$count = 0;

							foreach ($chk as $value) {
			          $value2 = explode(",", $value);
			          foreach ($value2 as $value3) {
			            if (strpos($mensaje, normaliza($value3)) !== false) {
			                $key = array_search($value, $chk);
			                $msg = $value3;
											$hooman[$count]['key'] = $key;
											$hooman[$count]['msg'] = strlen(utf8_decode($msg));
											$hooman[$count]['text'] = $msg;
			                $found = TRUE;
											$count++;
			            }
			          }
							}

			        if($found == TRUE){

								$esta = max(array_column($hooman, 'msg'));
								$key = array_search($esta, array_column($hooman, 'msg'));
								$msg = $hooman[$key]['text'];
								$key = $hooman[$key]['key'];

								$typeA = $exp[$key]['key'];

								$data['mensaje'] = getEncodeUrl($exp[$key]['mensaje']);

								if(	$exp[$key]['key'] == 2  ){

									$buttons = $this->Md_bot->getBotones($key);

			            foreach ($buttons as $btn) {
			              $data['botones'] .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
			            };

			          } else if(	$exp[$key]['key'] == 3 ){

									$image = $this->Md_bot->getImage($key);

			            foreach ($image as $img) {
			              $data['mensaje'] .= '</br><a href="https://fogatabot.com'.$img['key_url'].'" target="_blank"><img src="https://fogatabot.com'.$img['key_url'].'" width="100%"></a>';
			            };

			          } else if( $exp[$key]['key'] == 4 ){

									$buttons = $this->Md_bot->getEncuestas($key);

			            foreach ($buttons as $btn) {
			               $data['botones'] .= '<div data-id="'.$btn['bots_keys_id'].'" data-key="'.$btn['id'].'" class="encuesta-response fogata-encuesta-response">'.$btn['button'].'</div>';
			            };

			          } else if( $exp[$key]['key'] == 5 ){

									$combos = $this->Md_bot->getCombos($key);

									$galWidth = count($combos);
									$galWidth = 224 * $galWidth;

									$data['mensaje'] .= '<div class="fogata-gallery">';
									$data['mensaje'] .= '<div class="fogata-controls">
																				<div class="fogata-left-control" data-id="'.$key.'">
																					<i class="fas fa-chevron-left"></i>
																				</div>
																				<div class="fogata-right-control" data-id="'.$key.'">
																					<i class="fas fa-chevron-right"></i>
																				</div>
																		   </div>';

									$data['mensaje'] .= '<div style="width: '.$galWidth.'px" class="fogata-scroll fogata-scroll-'.$key.'">';

			            foreach ($combos as $combo) {
										$data['mensaje'] .= '<div class="fogata-tile">';
			              $data['mensaje'] .= '<a href="https://fogatabot.com'.$combo['key_url'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_url'].'" width="100%"></a>';
			              $data['mensaje'] .= '<p style="margin: 2px 0 1px"><b>'.$combo['title'].'</b></p>';
										if($combo['subtitle'] != '')
										$data['mensaje'] .= '<p style="margin: 1px 0 2px">'.$combo['subtitle'].'</p>';
			              $data['mensaje'] .= '<a href="'.$combo['image_url'].'" target="_blank"><div class="bot-button fogata-bot-button">'.$combo['button'].'</div></a>';
										$data['mensaje'] .= '</div>';
									};

									$data['mensaje'] .= '</div>';
									$data['mensaje'] .= '</div>';

			          } else if( $exp[$key]['key'] == 6 ){

										$combos = $this->Md_bot->getCombots($key);


										$galWidth = count($combos);
										$galWidth = 224 * $galWidth;

										$data['mensaje'] .= '<div class="fogata-gallery">';
										$data['mensaje'] .= '<div class="fogata-controls">
																				<div class="fogata-left-control" data-id="'.$key.'">
																						<i class="fas fa-chevron-left"></i>
																				</div>
																				<div class="fogata-right-control" data-id="'.$key.'">
																						<i class="fas fa-chevron-right"></i>
																				</div>
																				</div>';

										$data['mensaje'] .= '<div style="width: '.$galWidth.'px" class="fogata-scroll fogata-scroll-'.$key.'">';

										foreach ($combos as $combo) {
												$data['mensaje'] .= '<div class="fogata-tile">';
												$data['mensaje'] .= '<a href="https://fogatabot.com'.$combo['key_image'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_image'].'" width="100%"></a>';
												$data['mensaje'] .= '<div class="bot-button fogata-option-button">'.$combo['button'].'</div>';
												$data['mensaje'] .= '</div>';
										};

										$data['mensaje'] .= '</div>';
										$data['mensaje'] .= '</div>';

								} else if(strlen($exp[$key]['mensaje']) <= 7 && $exp[$key]['key'] == 1){

			            $data['mensaje'] = '<h2 style="color:#fff">'.$exp[$key]['mensaje'].'</h2>';

			          } else if(strlen($exp[$key]['mensaje']) <= 9 && $exp[$key]['key'] == 1){

			            $data['mensaje'] = '<h3 style="color:#fff">'.$exp[$key]['mensaje'].'</h3>';

			          };

								if($exp[$key]['mail_alert'] == 1) {
									$this->Md_bot->putAlerts($account[0]['id'], $ip, $device);
								}

								$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], $key, 0, $device, $word, $typeA);


			        } else {

								$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

								if( isset( $mensajes[0]['notfound'] ) && $mensajes[0]['notfound'] != '' ) {
									$data['mensaje'] = $mensajes[0]['notfound'];
								} else {
									$data['mensaje'] = 'Sorry, try again with another question. ☺';
								}

								$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], 0, 0, $device, $word, $typeA);


			        }


			} else if ($type == 2) {
				$respuesta = $this->Md_bot->getEncResp( $key );
				$respuestaID = $this->Md_bot->getEncRespId( $keyEncId );
			  $data['mensaje'] =  getEncodeUrl2( $respuesta[0]['text'] );
			  $msg = $respuestaID[0]['button'];
				$buttons = $this->Md_bot->getBotonesEnc($key);
				foreach ($buttons as $btn) {
					$data['botones'] .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
				};
				////error_log($ip. ' '.  $msg . ' '. 3 . ' '. $account[0]['id'] . ' '. $key . ' '. $keyID . ' '. $device . ' '. $word . ' '. $typeA);
				$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $keyId, $keyEncId, $device, $word, $typeA);

			} else {
				$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

				if( isset( $mensajes[0]['notfound'] ) && $mensajes[0]['notfound'] != '' ) {
					$data['mensaje'] = $mensajes[0]['notfound'];
				} else {
					$data['mensaje'] = 'Sorry, try again with another question. ☺';
				}
			}

			$data = json_encode($data);

			$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);
		}
	} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);

	}

	public function newchat_post() {

			$post = $this->post();
			$cleanPost = $this->security->xss_clean($post);

			$account = $this->Md_bot->getUser($cleanPost['auth']);
			$ip = $cleanPost['user'];
			$word = $cleanPost['msg'];
			$type = $cleanPost['type'];
			$key = $cleanPost['bots_key_id'];
			$device = $cleanPost['usr_dev'];
			$msg = FALSE;
			$data = [];
			$data['mensaje'] = '';
			$data['botones'] = '';
			$keyEncId = $cleanPost['keyenc_id'];
			$keyId = $cleanPost['keyenc'];

			function getEncodeUrl($text) {
				$retu =  base64_decode($text);
				$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
				$replace = preg_replace_callback($url, function($matches) {
						if( strlen($matches[0]) > 20 ) {
							$urlTxt = substr($matches[0], 0, 20).'...';
						} else {
							$urlTxt = $matches[0];
						}
						return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
				}, $retu);
				return $replace;
			}

			function getEncodeUrl2($text) {
				$retu =  $text;
				$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
				$replace = preg_replace_callback($url, function($matches) {
						if( strlen($matches[0]) > 20 ) {
							$urlTxt = substr($matches[0], 0, 20).'...';
						} else {
							$urlTxt = $matches[0];
						}
						return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
				}, $retu);
				return $replace;
			}

			function normaliza ($cadena){
				$originales =  'ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûýýþÿŔŕ?¿';
				$modificadas = 'aaaaaaaceeeeiiiidnoooooouuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyRr?¿';
				$cadena = utf8_decode($cadena);
				$cadena = strtr($cadena, utf8_decode($originales), $modificadas);
				$cadena = strtolower($cadena);
				return utf8_encode($cadena);
			}



			if ( isset($account[0]) ) {

				$cycles = $this->Md_bot->getCycle($ip, $device, $account[0]['id']);
				//aki
				$typeA = 0;
				if($cycles){
					////error_log( 'llega mierda ' . $type);
					$respuesta = $this->Md_bot->getEncResp( $cycles );
					//$respuestaID = $this->Md_bot->getEncRespId( $keyID );
					$data['mensaje'] =  getEncodeUrl2( $respuesta[0]['text'] );
					//$msg = $respuestaID[0]['button'];
					$buttons = $this->Md_bot->getBotonesEnc( $cycles );
					foreach ($buttons as $btn) {
						$data['botones'] .= '<div data-id="'.$respuesta[0]['id'].'" class="fogata-encuesta-callback">'.$btn['button'].'</div>';
					};

					$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $keyId, $keyEncId, $device, $word, $typeA);
				//	$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], $key, 0, $device, $word, $typeA);
					//$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $key, 0, $device, $word);

					$data = json_encode($data);
					$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);

				} else {

				$keys = $this->Md_bot->getKeys($account[0]['id']);

				if ($type == 1 && count($keys) > 0) {

							$mensaje = strtolower($word);
							$mensaje = urldecode($mensaje);
							$mensaje = normaliza($mensaje);

							//$hilos = json_decode($keys);

							foreach ($keys as $value) {
								$exp[ $value['id'] ]['id']= $value['id'];
								$exp[ $value['id'] ]['key']= $value['key_group'];
								$exp[ $value['id'] ]['mensaje']= $value['mensaje'];
								$exp[ $value['id'] ]['mail_alert']= $value['mail_alert'];
								$chk[ $value['id'] ] = strtolower($value['key']);
								//echo normaliza(strtolower($value->key)).'  //  ';
							}

							$found = FALSE;
							$count = 0;

							foreach ($chk as $value) {
								$value2 = explode(",", $value);
								foreach ($value2 as $value3) {
									if (strpos($mensaje, normaliza($value3)) !== false) {
											$key = array_search($value, $chk);
											$msg = $value3;
											$hooman[$count]['key'] = $key;
											$hooman[$count]['msg'] = strlen(utf8_decode($msg));
											$hooman[$count]['text'] = $msg;
											$found = TRUE;
											$count++;
									}
								}
							}

							if($found == TRUE){

								$esta = max(array_column($hooman, 'msg'));
								$key = array_search($esta, array_column($hooman, 'msg'));
								$msg = $hooman[$key]['text'];
								$key = $hooman[$key]['key'];

								$typeA = $exp[$key]['key'];

								$data['mensaje'] = getEncodeUrl($exp[$key]['mensaje']);

								if(	$exp[$key]['key'] == 2  ){

									$buttons = $this->Md_bot->getBotones($key);

									foreach ($buttons as $btn) {
										$data['botones'] .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
									};

								} else if(	$exp[$key]['key'] == 3 ){

									$image = $this->Md_bot->getImage($key);

									foreach ($image as $img) {
										$data['mensaje'] .= '</br><a href="https://fogatabot.com'.$img['key_url'].'" target="_blank"><img src="https://fogatabot.com'.$img['key_url'].'" width="100%"></a>';
									};

								} else if( $exp[$key]['key'] == 4 ){

									$buttons = $this->Md_bot->getEncuestas($key);

									foreach ($buttons as $btn) {
										 $data['botones'] .= '<div data-id="'.$btn['bots_keys_id'].'" data-key="'.$btn['id'].'" class="encuesta-response fogata-encuesta-response">'.$btn['button'].'</div>';
									};

								} else if( $exp[$key]['key'] == 5 ){

									$combos = $this->Md_bot->getCombos($key);

									$galWidth = count($combos);
									$galWidth = 224 * $galWidth;

									$data['mensaje'] .= '<div class="fogata-gallery">';
									$data['mensaje'] .= '<div class="fogata-controls">
																				<div class="fogata-left-control" data-id="'.$key.'">
																					<i class="fas fa-chevron-left"></i>
																				</div>
																				<div class="fogata-right-control" data-id="'.$key.'">
																					<i class="fas fa-chevron-right"></i>
																				</div>
																			 </div>';

									$data['mensaje'] .= '<div style="width: '.$galWidth.'px" class="fogata-scroll fogata-scroll-'.$key.'">';

									foreach ($combos as $combo) {
										$data['mensaje'] .= '<div class="fogata-tile">';
										$data['mensaje'] .= '<a href="https://fogatabot.com'.$combo['key_url'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_url'].'" width="100%"></a>';
										$data['mensaje'] .= '<p style="margin: 2px 0 1px"><b>'.$combo['title'].'</b></p>';
										if($combo['subtitle'] != '')
										$data['mensaje'] .= '<p style="margin: 1px 0 2px">'.$combo['subtitle'].'</p>';
										$data['mensaje'] .= '<a href="'.$combo['image_url'].'" target="_blank"><div class="bot-button fogata-bot-button">'.$combo['button'].'</div></a>';
										$data['mensaje'] .= '</div>';
									};

									$data['mensaje'] .= '</div>';
									$data['mensaje'] .= '</div>';

								} else if( $exp[$key]['key'] == 6 ){

										$combos = $this->Md_bot->getCombots($key);


										$galWidth = count($combos);
										$galWidth = 224 * $galWidth;

										$data['mensaje'] .= '<div class="fogata-gallery">';
										$data['mensaje'] .= '<div class="fogata-controls">
																				<div class="fogata-left-control" data-id="'.$key.'">
																						<i class="fas fa-chevron-left"></i>
																				</div>
																				<div class="fogata-right-control" data-id="'.$key.'">
																						<i class="fas fa-chevron-right"></i>
																				</div>
																				</div>';

										$data['mensaje'] .= '<div style="width: '.$galWidth.'px" class="fogata-scroll fogata-scroll-'.$key.'">';

										foreach ($combos as $combo) {
												$data['mensaje'] .= '<div class="fogata-tile">';
												$data['mensaje'] .= '<a href="https://fogatabot.com'.$combo['key_image'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_image'].'" width="100%"></a>';
												$data['mensaje'] .= '<div class="bot-button fogata-option-button">'.$combo['button'].'</div>';
												$data['mensaje'] .= '</div>';
										};

										$data['mensaje'] .= '</div>';
										$data['mensaje'] .= '</div>';

								} else if(strlen($exp[$key]['mensaje']) <= 7 && $exp[$key]['key'] == 1){

									$data['mensaje'] = '<h2 style="color:#fff">'.$exp[$key]['mensaje'].'</h2>';

								} else if(strlen($exp[$key]['mensaje']) <= 9 && $exp[$key]['key'] == 1){

									$data['mensaje'] = '<h3 style="color:#fff">'.$exp[$key]['mensaje'].'</h3>';

								};

								if($exp[$key]['mail_alert'] == 1) {
									$this->Md_bot->putAlerts($account[0]['id'], $ip, $device);
								}

								$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], $key, 0, $device, $word, $typeA);


							} else {

								$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

								if( isset( $mensajes[0]['notfound'] ) && $mensajes[0]['notfound'] != '' ) {
									$data['mensaje'] = $mensajes[0]['notfound'];
								} else {
									$data['mensaje'] = 'Sorry, try again with another question. ☺';
								}

								$this->Md_bot->putMsg($ip, $msg, 0, $account[0]['id'], 0, 0, $device, $word, $typeA);


							}


			} else if ($type == 2) {
				$respuesta = $this->Md_bot->getEncResp( $key );
				$respuestaID = $this->Md_bot->getEncRespId( $keyEncId );
				$data['mensaje'] =  getEncodeUrl2( $respuesta[0]['text'] );
				$msg = $respuestaID[0]['button'];
				$buttons = $this->Md_bot->getBotonesEnc($key);
				foreach ($buttons as $btn) {
					$data['botones'] .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
				};
				////error_log($ip. ' '.  $msg . ' '. 3 . ' '. $account[0]['id'] . ' '. $key . ' '. $keyID . ' '. $device . ' '. $word . ' '. $typeA);
				$this->Md_bot->putMsg($ip, $msg, 3, $account[0]['id'], $keyId, $keyEncId, $device, $word, $typeA);

			} else {
				$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

				if( isset( $mensajes[0]['notfound'] ) && $mensajes[0]['notfound'] != '' ) {
					$data['mensaje'] = $mensajes[0]['notfound'];
				} else {
					$data['mensaje'] = 'Sorry, try again with another question. ☺';
				}
			}

			$data = json_encode($data);

			$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);
		}
	} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);

	}













	
	public function chatbotBce_post() {

		$post = $this->post();
		$cleanPost = $this->security->xss_clean($post);

		$account = $this->Md_bot->getTelegram($cleanPost['account_id']);
		$user_id = $cleanPost['user_id'];
		$chatId = $cleanPost['chatId'];
		$typeTl = $cleanPost['typeTl'];
		$word = $cleanPost['msg'];
		$username = $cleanPost['username'];

		$data = [];
		$data['mensaje'] = '';
		$data['botones'] = '';
		$msg = "";
		
		log_message('error', 'Some variable did not contain a value.');

		function normaliza ($cadena){
			$originales =  'ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûýýþÿŔŕ?¿';
			$modificadas = 'aaaaaaaceeeeiiiidnoooooouuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyRr?¿';
			$cadena = utf8_decode($cadena);
			$cadena = strtr($cadena, utf8_decode($originales), $modificadas);
			$cadena = strtolower($cadena);
			$cadena = utf8_encode($cadena);
			return urldecode($cadena);
		}

		$message = strtolower($word);
		$message = urldecode($message);
		$message = normaliza($message);

		if ( isset($account[0]) ) {

			$userData = $this->Md_bot->putMsgBots($user_id, 1, $account[0]['id'], 0, $word, 'telegram', $username, '', '');



			if($userData['bot_cycle'] && $userData['active'] == 0){

				$data['mensaje'] = '<b>bold</b>, <strong>bold</strong>
				<i>italic</i>, <em>italic</em>
				<u>underline</u>, <ins>underline</ins>
				<s>strikethrough</s>, <strike>strikethrough</strike>, <del>strikethrough</del>
				<b>bold <i>italic bold <s>italic bold strikethrough</s> <u>underline italic bold</u></i> bold</b>
				<a href="http://www.example.com/">inline URL</a>
				<a href="tg://user?id=123456789">inline mention of a user</a>
				<code>inline fixed-width code</code>
				<pre>pre-formatted fixed-width code block</pre>
				<pre><code class="language-python">pre-formatted fixed-width code block written in the Python programming language</code></pre>';

				$data['mensaje'] = '';
				$data['botones'] = '';

				if(strpos($message, normaliza('ayuda')) !== false) {

					$msg=urlencode("Para volver al inicio de este proceso puede escribir la palabra <b>Menú</b>");
					$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
					$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

				} else if(strpos($message, normaliza('menu')) !== false) {

					$hora = date("H");

					if($hora >= 12 && $hora < 19){
						$respuesta="Buenas tardes";
					} else if($hora > 6 && $hora > 12){
						$respuesta="Buenos días";
					} else {
						$respuesta="Buenas noches";
					}

					$this->Md_bot->updateCycleTelegram(1,$userData['id']);
					$msg=urlencode("¡$respuesta $username!, mi nombre es XX de eNext, la nueva era en firma electrónica.");
					$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
					$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

					$msg=urlencode("Por favor escribe una de estas opciones:

					<b>1</b> - eAdvance One
					<b>2</b> - eAdvance Basic
					<b>3</b> - eAdvance Plus");
					$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
					$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

				} else if($userData['bot_cycle'] == 1) {
					if(strpos($message, normaliza('one')) !== false || strpos($message, normaliza('1')) !== false) {

						$msg=urlencode("Es un placer para mi poder asistirle durante el proceso de obtención de su nueva firma electrónica eAdvance One. ");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$msg=urlencode('Hoy estamos de promoción por tiempo limitado, por tan solo 0,60 centavos / mes usted podrá acceder al paquete de eAdvance Plus. Que incluye (incluir la imagen utilizada en la pagina web con los atributos de eA Plus)');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("¿Le gustaría aprovechar esta super promoción? 

<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(2,$userData['id']);
				  
					  } else if(strpos($message, normaliza('basic')) !== false || strpos($message, normaliza('2')) !== false) {
		  
						$msg=urlencode("Es un placer para mi poder asistirle durante el proceso de obtención de su nueva firma electrónica eAdvance Basic.");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$msg=urlencode('Hoy estamos de promoción por tiempo limitado, por tan solo 0,32 centavos / mes usted podrá acceder al paquete de eAdvance Plus. Que incluye (incluir la imagen utilizada en la pagina web con los atributos de eA Plus)');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("¿Le gustaría aprovechar esta super promoción? 

<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(2,$userData['id']);
				  
					  } else if(strpos($message, normaliza('plus')) !== false || strpos($message, normaliza('3')) !== false) {
		  
						$msg=urlencode("Es un placer para mi poder asistirle durante el proceso de obtención de su nueva firma electrónica eAdvance Plus.");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$msg=urlencode($username.", es importante que tenga a la mano los siguientes documentos y que este de acuerdo con el contrato de condiciones de uso:

1) Cédula de ciudadanía");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$msg=urlencode('<a href="https://api.fogatabot.com/uploads/modelo-ecuador.png">Para este proceso solo se acepta este formato de cédula de identidad</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');


$msg=urlencode("2) Papeleta de votación vigente (exceptuando a personas mayores a sesenta y cinco años, a las ecuatorianas y ecuatorianos que habitan en el exterior, los integrantes de las Fuerzas Armadas y Policía Nacional, y las personas con discapacidad)
3) Última factura de pago de servicio basico (luz, agua o teléfono)
4) Tarjeta de crédito o débito");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');


$msg=urlencode("¿Está de acuerdo?
<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(3,$userData['id']);
				  
					  } else {
$msg=urlencode("Por favor escribe una de estas opciones:

<b>1</b> - eAdvance One
<b>2</b> - eAdvance Basic
<b>3</b> - eAdvance Plus");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 2){

					if(strpos($message, normaliza('si')) !== false || strpos($message, normaliza('1')) !== false) {
					
						$msg=urlencode("Felicitaciones! Usted accedió a una excelente promoción. Vamos a continuar ahora con la emisión de su nueva firma electrónica eAdvance Plus ");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

					} else if (strpos($message, normaliza('no')) !== false || strpos($message, normaliza('2')) !== false) {
					
$msg=urlencode("De acuerdo! Recuerde que cuando usted guste puede adquirir nuestros servicios y productos complementarios");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$msg=urlencode($username.", es importante que tenga a la mano los siguientes documentos y que este de acuerdo con el contrato de condiciones de uso:

1) Cédula de ciudadanía");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$msg=urlencode('<a href="https://api.fogatabot.com/uploads/modelo-ecuador.png">Para este proceso solo se acepta este formato de cédula de identidad</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');


$msg=urlencode("2) Papeleta de votación vigente (exceptuando a personas mayores a sesenta y cinco años, a las ecuatorianas y ecuatorianos que habitan en el exterior, los integrantes de las Fuerzas Armadas y Policía Nacional, y las personas con discapacidad)
3) Última factura de pago de servicio basico (luz, agua o teléfono)
4) Tarjeta de crédito o débito");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');


$msg=urlencode("¿Está de acuerdo?
<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(3,$userData['id']);
					
					} else {

$msg=urlencode("¿Le gustaría aprovechar esta super promoción? 

<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');	
					}

				} else if($userData['bot_cycle'] == 3) {

					if(strpos($message, normaliza('si')) !== false || strpos($message, normaliza('1')) !== false) {
				  
$msg=urlencode("🙂 Perfecto, ahora necesito sus nombres y apellidos completos.");
						$this->Md_bot->updateCycleTelegram(4,$userData['id']);
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

					}  else if (strpos($message, normaliza('no')) !== false || strpos($message, normaliza('2')) !== false) {

$msg=urlencode("En el caso de no aceptar el contrato de condiciones de uso usted no podrá avanzar con la compra, ¿por favor acepte el contrato de condiciones de uso para continuar?

<b>1</b> - Si, acepto
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');	
					} else {

$msg=urlencode("¿Está de acuerdo?

<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');	
					}

				} else if($userData['bot_cycle'] == 4){

					if(strpos($message, normaliza(' ')) !== false && !preg_match('~[0-9]+~', $message)) {

						$options = array('nombre' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);
		  
						$msg=urlencode("$username, por favor ingrese su <b>número de cédula</b> <i>(sin espacios o guiones)</i>");
						$this->Md_bot->updateCycleTelegram(5,$userData['id']);
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
				  
					  } else {
						$msg=urlencode("Debe al menos escribir un <b>nombre y un apellido</b> sin caracteres especialos o números");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 5) {

					/*Cédula de ciudadanía:
					El proceso para la validación es el siguiente:
					* La cédula ecuatoriana está formada por los dos primeros dígitos que corresponden a la provincia donde fue expedida, por lo cual, los dos primeros dígitos no serán mayores a 24 ni menores a 0.
					* El tercer dígito es un número menor a 6 (0,1,2,3,4,5).
					* Los siguientes hasta el noveno dígito son un número consecutivo.
					* El décimo es el dígito verificador.
					Los coeficientes usados para verificar el décimo dígito de la cédula, mediante el “Módulo 10”.*/

					if(isset($message[0]) && isset($message[1])) {
						$provincia =$message[0].$message[1];
						if($provincia <= 25) $test = TRUE;
						else $test = FALSE;
					} else $test = FALSE;

					if(isset($message[2])) {
						$tercer = $message[2];
						if($tercer < 6) $test2 = TRUE;
						else $test2 = FALSE;
					} else $test2 = FALSE;

					if(preg_match('~[0-9]+~', $message) && strlen($message) == 10 && $test && $test2) {

						$options = array('cedula' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("¡Excelente! Ahora necesito un número <b>celular personal</b>, sin guiones, puntos o espacios 📱");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(6,$userData['id']);
				  
					  } else {
						$msg=urlencode("Por favor ingrese su número de cédula válido (sin espacios o guiones)");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/modelo-ecuador.png">Para este proceso solo se acepta este formato de cédula de identidad</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 6) {


					if(preg_match('~[0-9]+~', $message) && strlen($message) >= 7) {

						$options = array('celular' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("Necesito también un <b>número convencional</b>, puede ser de su casa u oficina, sin guiones, puntos o espacios 📱");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(7,$userData['id']);
				  
					  } else {
						$msg=urlencode("Por favor ingrese nuevamente su <b>número de celular</b> válido, sin guiones, puntos o espacios");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 7) {

					if(preg_match('~[0-9]+~', $message) && strlen($message) >= 7) {

						$options = array('telefono' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("$username, estamos cerca, solo nos falta un <b>correo electrónico personal</b>. 📧
<i>Le recuerdo que es necesario que el correo que ingrese sea de su propiedad, durante este proceso enviaré información y codigos de verificación para poder completar la emisión de su firma electrónica</i>");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(8,$userData['id']);
				  
					  } else {
						$msg=urlencode("Por favor ingrese nuevamente su <b>número de teléfono</b> válido, sin guiones, puntos o espacios");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 8) {

					if(preg_match("/^[^@]+@[^@]+\.[a-z]{2,6}$/i", $message) && strlen($message) >= 6) {

						$options = array('email' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("Estimado $username, gracias por la información brindada!.");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("En este momento voy a iniciar el proceso de validación de identidad con nuestro sistema de seguridad biométrico. ");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("Por favor envía una <b>imagen de tu cédula</b> donde se vea tu foto y tu número de cédula sea legible");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(9,$userData['id']);
				  
					  } else {
						$msg=urlencode("Por favor debe ingresar un correo electrónico válido");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 9) {

					if($typeTl == 'image') {

						$options = array('image1' => $word);

						$this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("Ahora envíe <b>una foto suya</b> que se pueda apreciar su rostro sin lentes");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(10,$userData['id']);
				  
					  } else {
						$msg=urlencode("Por favor envía una imagen de tu cédula donde se vea tu foto y tu número de cédula sea legible");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }
				} else if($userData['bot_cycle'] == 10) {

					if($typeTl == 'image') {

						$options = array('image2' => $word);

						$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);
						$response = $this->Md_bot->amazonRegognition($image1['image1'], $word);
						
						//if(isset($response->FaceMatches[0]->Similarity)) {
						if(1==1) {


							$options = array('amazon' => json_decode('asdasda '.$response));

							$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

							$similarity = $response->FaceMatches[0]->Similarity;

							//if($similarity >= 80) {
							if(2==2) {

								$msg=urlencode("Muy Bien, he concluido la validación de su identidad con éxito ");
								$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
								$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

								$msg=urlencode("$username, he enviado un codigo OTP al correo electrónico que proporcionó anteriormente.");
								$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
								$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

								$msg=urlencode("¡Por favor ingrese ese código ahora! Le recuerdo que <b>el código tiene validez de 5 minutos. </b>
<i>Código: 1234567</i>");
								$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
								$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

								$this->Md_bot->updateCycleTelegram(11,$userData['id']);

							} else {
								$msg=urlencode("No he podido validar su identidad, si necesita ayuda o tiene alguna duda, por favor revise nuestra seección de preguntas frecuentes o contactese con nuestro servicio de atención al cliente al XXXXXXX, lo ayudaremos de inmediato. Gracias por visitarnos, lo esperamos pronto! ");
								$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
								$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
								$this->Md_bot->updateCycleTelegram(0,$userData['id']);
							}
						} else {
							$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

							$msg=urlencode("No he podido validar su identidad, si necesita ayuda o tiene alguna duda, por favor revise nuestra seección de preguntas frecuentes o contactese con nuestro servicio de atención al cliente al XXXXXXX, lo ayudaremos de inmediato. Gracias por visitarnos, lo esperamos pronto! ");
							$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
							$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
							$this->Md_bot->updateCycleTelegram(0,$userData['id']);
						}
				  
					  } else {
					//	$this->Md_bot->updateCycleTelegram(5,$userData['id']);
						$msg=urlencode("Por favor envía una imagen de tu cédula donde se vea tu foto y tu número de cédula sea legible");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 11) {

					if(strpos($message, normaliza('1234567')) !== false) {

						$msg=urlencode("Muy bien $username, ahora debe cargar la documentación, esto proceso será fácil y rápido. Recuerde, necesito su cédula de identidad, papeleta de votación y factura de servicio báscio actual.");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("¿Usted prefiere cargar su documentación en formato PDF o usando la camará de su dispositivo para sacarle fotos a sus documentos en este momento? 
<b>1</b> - PDF
<b>2</b> - FOTO");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$this->Md_bot->updateCycleTelegram(12,$userData['id']);
				  
					  } else {
						$msg=urlencode("El código OTP que ingreso <b>no es válido</b>, por favor vuelva a ingresarlo");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 12) {

					if(strpos($message, normaliza('pdf')) !== false || strpos($message, normaliza('1')) !== false) {

						$msg=urlencode("Los archivos PDF no deben pasar de los XX Kb");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/bce2.png">Envíe el arvhivo en formato PDF a través de Telegram</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$this->Md_bot->updateCycleTelegram(13,$userData['id']);
				  
					} else if(strpos($message, normaliza('foto')) !== false || strpos($message, normaliza('2')) !== false) {
						$msg=urlencode("La foto de la cédula de identidad debe ser tomada de los dos lados");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/bce2.png">Envíe la foto de su cédula de identidad del lado frontal</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						
						$this->Md_bot->updateCycleTelegram(14,$userData['id']);
					} else {
						$msg=urlencode("¿Usted prefiere cargar su documentación en formato PDF o usando la camará de su dispositivo para sacarle fotos a sus documentos en este momento? 
<b>1</b> - PDF
<b>2</b> - FOTO");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					  }

				} else if($userData['bot_cycle'] == 13) {

					if($typeTl == 'document') {
						$options = array('document' => $word);

						$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("¡Buen trabajo! Ahora voy a receptar su pago");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("Escriba <b>Pagado</b> para continuar
<i>Puede escribir cualquier palabra</i>");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(16,$userData['id']);

					} else {
						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/bce2.png">Envíe el arvhivo en formato PDF a través de Telegram</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
					}

				} else if($userData['bot_cycle'] == 14) {

					if($typeTl == 'image') {

						$options = array('image1' => $word);

						$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/cedula-posterior.png">Ahora envíe la foto de su cédula de identidad del lado posterior</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
	
						$this->Md_bot->updateCycleTelegram(14,$userData['id']);
					} else {
						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/cedula.png">Por favor envíe la foto de su cédula de identidad del lado frontal</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
	
						$this->Md_bot->updateCycleTelegram(14,$userData['id']);
					}

				} else if($userData['bot_cycle'] == 15) {

					if($typeTl == 'image') {

						$options = array('image2' => $word);

						$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("¡Buen trabajo! Ahora voy a receptar su pago");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$msg=urlencode("Escriba <b>Pagado</b> para continuar");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

						$this->Md_bot->updateCycleTelegram(16,$userData['id']);
					} else {
						$msg=urlencode('<a href="https://api.fogatabot.com/uploads/cedula-posterior.png">Ahora envíe la foto de su cédula de identidad del lado posterior</a>');
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
	
						$this->Md_bot->updateCycleTelegram(14,$userData['id']);
					}

				} else if($userData['bot_cycle'] == 16) {

						$msg=urlencode("¿Usted neceista la factura con sus datos?
<b>1</b> - Si
<b>2</b> - No");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
	
						$this->Md_bot->updateCycleTelegram(17,$userData['id']);
					}

					else if($userData['bot_cycle'] == 17) {
						if(strpos($message, normaliza('si')) !== false || strpos($message, normaliza('1')) !== false) {
	
							$msg=urlencode("Por favor ingrese su dirección y ciudad de residencia");
							$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
							$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
							$this->Md_bot->updateCycleTelegram(18,$userData['id']);
	
						} else if(strpos($message, normaliza('no')) !== false || strpos($message, normaliza('2')) !== false) {
							$msg=urlencode("¿Usted neceista la factura con sus datos?
		<b>1</b> - Si
		<b>2</b> - No");
							$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
							$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						} else {
							$msg=urlencode("¿Usted neceista la factura con sus datos?
		<b>1</b> - Si
		<b>2</b> - No");
							$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
							$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						}
	

				} else if($userData['bot_cycle'] == 18) {
					

					$options = array('direccion' => $word);

					$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);
					

						$msg=urlencode("<b>La factura se ha enviado a su correo electrónico</b>");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(18,$userData['id']);

						$msg=urlencode("$username, está a pocos minutos de recibir su firma electrónica 🙂");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(18,$userData['id']);

						$msg=urlencode("Necesito que genere una contraseña para su firma electrónica.");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(18,$userData['id']);

						$msg=urlencode("La contraseña debe incluir letras <b>Mayúsculas, minúsculas, números y simbolos</b>. No puede ser menos de 8 caracteres");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(18,$userData['id']);

						$msg=urlencode("Es importante recordarle que no debe perder esta contraseña, en el caso de pérdida podrá recuperarla por una sola vez.

Escriba su contraseña a continuación:
<i>Avxs@@123123</i>");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(19,$userData['id']);

					
				} else if($userData['bot_cycle'] == 19) {


					$options = array('password' => $word);

					$image1 = $this->Md_bot->updateOption($userData['id'], $options, 'telegram', 286);

						$msg=urlencode("Estamos a dos pasos de finalizar, antes debe firmar el contrato de su firma electrónica");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(18,$userData['id']);
						$msg=urlencode("Buen trabajo $username, hemos finalizado este proceso en tiempo record 🙂, ahora ya puede usar su firma electrónca eAdvance

Recuerde ingresar a nuestra web <b>www.enextecu.com</b> para  acceder a su firma electrónica y demás servicios, utilizando el usuario y contraseña que creo anteriormente.						

Para nosotros es muy importante satisfacer las necesidades de nuestros clientes, por favor ayudanos contestando esta encuesta

Si tiene alguna duda sobre el uso de su certificado digital recuerde que nos puede contactar por este medio o a través de nuestro canal de atención al cliente al 02666777.

Gracias por preferirnos. Recuerde que estamos para servirlo. <b>eNext</b>, la nueva era en firma electrónica");
						$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
						$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');
						$this->Md_bot->updateCycleTelegram(0,$userData['id']);

		
						$data['mensaje'] = $msg;

					} 


				
			/*	$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $data['mensaje']);*/

				$data = json_encode($data);
				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);

			} else {

				if($userData['bot_cycle']==0){
					$this->Md_bot->updateCycleTelegram(1,$userData['id']);
				}
$hora = date("H");

if($hora >= 12 && $hora < 19){
	$respuesta="Buenas tardes";
} else if($hora > 6 && $hora > 12){
	$respuesta="Buenos días";
} else {
	$respuesta="Buenas noches";
}

$msg=urlencode("¡$respuesta $username!, mi nombre es XX de eNext, la nueva era en firma electrónica.");
$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$msg=urlencode("Por favor escribe una de estas opciones:

<b>1</b> - eAdvance One
<b>2</b> - eAdvance Basic
<b>3</b> - eAdvance Plus");
$this->Md_bot->sendTelegram($account[0]['token'], $chatId, $msg);
$this->Md_bot->putMsgBots($user_id, 0, $account[0]['id'], 0, $msg, 'telegram', $username, '', '');

$data['mensaje'] = $msg;
				$data = json_encode($data);
				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);
			}
		 
		} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'Usuario no encontrado'], REST_Controller::HTTP_OK);

	}

	/*
		public function webchat_put() {

				$post = $this->put();
				$cleanPost = $this->security->xss_clean($post);

				$account = $this->Md_bot->getUser($cleanPost['auth']);
				$ip = $cleanPost['user'];
				$word = $cleanPost['msg'];
				$type = $cleanPost['type'];
				$key = $cleanPost['bots_key_id'];
				$device = $cleanPost['usr_dev'];
				$msg = FALSE;

				function getEncodeUrl($text) {
			 		$retu =  base64_decode($text);
			 		$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
					$replace = preg_replace_callback($url, function($matches) {
							if( strlen($matches[0]) > 20 ) {
								$urlTxt = substr($matches[0], 0, 20).'...';
							} else {
								$urlTxt = $matches[0];
							}
					    return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
					}, $retu);
			 		return $replace;
			 	}

				function getEncodeUrl2($text) {
					$retu =  $text;
					$url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
					$replace = preg_replace_callback($url, function($matches) {
							if( strlen($matches[0]) > 20 ) {
								$urlTxt = substr($matches[0], 0, 20).'...';
							} else {
								$urlTxt = $matches[0];
							}
					    return '<b><a href="'.$matches[0].'" target="_blank" title="'.$matches[0].'">'.$urlTxt.'</a></b>';
					}, $retu);
			 		return $replace;
				}

				function normaliza ($cadena){
					$originales =  'ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûýýþÿŔŕ?¿';
					$modificadas = 'aaaaaaaceeeeiiiidnoooooouuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyRr?¿';
					$cadena = utf8_decode($cadena);
					$cadena = strtr($cadena, utf8_decode($originales), $modificadas);
					$cadena = strtolower($cadena);
					$cadena = utf8_encode($cadena);
					return urldecode($cadena);
				}

				if ( isset($account[0]) ) {
					$keys = $this->Md_bot->getKeys($account[0]['id']);

					if ($type == 1) {

				        $mensaje = normaliza($mensaje);

				        //$hilos = json_decode($keys);

								foreach ($keys as $value) {
									$exp[ $value['id'] ]['id']= $value['id'];
									$exp[ $value['id'] ]['key']= $value['key_group'];
									$exp[ $value['id'] ]['mensaje']= $value['mensaje'];
									$chk[ $value['id'] ] = strtolower($value['key']);
				          //echo normaliza(strtolower($value->key)).'  //  ';
								}

								$found = FALSE;
								$count = 0;

								foreach ($chk as $value) {
				          $value2 = explode(",", $value);
				          foreach ($value2 as $value3) {
				            if (strpos($mensaje, normaliza($value3)) !== false) {
				                $key = array_search($value, $chk);
				                $msg = $value3;
												$hooman[$count]['key'] = $key;
												$hooman[$count]['msg'] = strlen(utf8_decode($msg));
												$hooman[$count]['text'] = $msg;
				                $found = TRUE;
												$count++;
				            }
				          }
								}

				        if($found == TRUE){

									$esta = max(array_column($hooman, 'msg'));
									$key = array_search($esta, array_column($hooman, 'msg'));
									$msg = $hooman[$key]['text'];
									$key = $hooman[$key]['key'];



									$exp[$key]['mensaje'] = getEncodeUrl($exp[$key]['mensaje']);

									if(	$exp[$key]['key'] == 2  ){
										$buttons = $this->Md_bot->getBotones($key);

				            $exp[$key]['mensaje'] .= '<div style="width:100%;float:left;">';
				            foreach ($buttons as $btn) {
				              $exp[$key]['mensaje'] .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
				            };
				            $exp[$key]['mensaje'] .= '</div>';

				          } else if(	$exp[$key]['key'] == 3 ){

										$image = $this->Md_bot->getImage($key);
				            $exp[$key]['mensaje'] .= '<div style="width:100%;float:left;">';
				            foreach ($image as $img) {
				              $exp[$key]['mensaje'] .= '</br><a href="https://fogatabot.com'.$img['key_url'].'" target="_blank"><img src="https://fogatabot.com'.$img['key_url'].'" width="100%"></a>';
				            };
				            $exp[$key]['mensaje'] .= '</div>';

				          } else if( $exp[$key]['key'] == 4 ){

										$buttons = $this->Md_bot->getEncuestas($key);
				            $exp[$key]['mensaje'] .= '<div style="width:100%;float:left;">';
				            foreach ($buttons as $btn) {
				              $exp[$key]['mensaje'] .= '<div data-id="'.$btn['bots_keys_id'].'" data-key="'.$btn['id'].'" class="encuesta-response fogata-encuesta-response">'.$btn['button'].'</div>';
				            };
				            $exp[$key]['mensaje'] .= '</div>';

				          } else if( $exp[$key]['key'] == 5 ){

										$combos = $this->Md_bot->getCombos($key);

				            $exp[$key]['mensaje'] .= '<div style="width:100%;float:left;" class="bots-gallery">';
				            foreach ($combos as $combo) {
											$exp[$key]['mensaje'] .= '<div class="bots-tile">';
				              $exp[$key]['mensaje'] .= '</br><a href="https://fogatabot.com'.$combo['key_url'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_url'].'" width="100%"></a>';
				              $exp[$key]['mensaje'] .= '<p style="margin: 2px 0 1px"><b>'.$combo['title'].'</b></p>';
				              $exp[$key]['mensaje'] .= '<p style="margin: 1px 0 2px">'.$combo['subtitle'].'</p>';
				              $exp[$key]['mensaje'] .= '<a href="'.$combo['image_url'].'" target="_blank"><div class="bot-button fogata-bot-button">'.$combo['button'].'</div></a>';
											$exp[$key]['mensaje'] .= '</div>';
				            };
				            $exp[$key]['mensaje'] .= '</div>';

				          } else if( $exp[$key]['key'] == 6 ){

										$combos = $this->Md_bot->getCombots($key);

				            $exp[$key]['mensaje'] .= '<div style="width:100%;float:left;" class="deste">';
				            foreach ($combos as $combo) {

				              $exp[$key]['mensaje'] .= '</br><a href="https://fogatabot.com'.$combo['key_image'].'" target="_blank"><img style="margin-top: 15px;" src="https://fogatabot.com'.$combo['key_image'].'" width="100%"></a>';
				              $exp[$key]['mensaje'] .= '<div class="option-button fogata-bot-button">'.$combo['button'].'</div>';

				            };
				            $exp[$key]['mensaje'] .= '</div>';

				          } else if(strlen($exp[$key]['mensaje']) <= 7 && $exp[$key]['key'] == 1){

				            $exp[$key]['mensaje'] = '<h2 style="color:#fff">'.$exp[$key]['mensaje'].'</h2>';

				          } else if(strlen($exp[$key]['mensaje']) <= 9 && $exp[$key]['key'] == 1){

				            $exp[$key]['mensaje'] = '<h3 style="color:#fff">'.$exp[$key]['mensaje'].'</h3>';

				          };

				          $data = $exp[$key]['mensaje'];

				        } else {

									$mensajes = $this->Md_bot->getMensajes($account[0]['id']);

									if( isset( $mensajes[0]['notfound'] ) && $mensajes[0]['notfound'] != '' ) {
										$data = $mensajes[0]['notfound'];
									} else {
										$data = 'Sorry, try again with another question. ☺';
									}

				        }

					$this->Md_bot->putMsgOld($ip, $msg, 0, $account[0]['id'], $key, 0, $device, $word);

				} else if ($type == 2) {
					$keyID = $cleanPost['keyenc_id'];
					$key = $cleanPost['keyenc'];
					$respuesta = $this->Md_bot->getEncResp( $key );
					$respuestaID = $this->Md_bot->getEncRespId( $keyID );
				  $data =  getEncodeUrl2( $respuesta[0]['text'] );
				  $msg = $respuestaID[0]['button'];


					$buttons = $this->Md_bot->getBotonesEnc($key);

					$data .= '<div style="width:100%;float:left;">';
					foreach ($buttons as $btn) {
						$data .= '<div class="option-button fogata-option-button">'.$btn['button'].'</div>';
					};
					$data .= '</div>';

					$this->Md_bot->putMsgOld($ip, $msg, 3, $account[0]['id'], $key, $keyID, $device, $word);
				}

				$this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => $data], REST_Controller::HTTP_OK);
		} else $this->set_response(['status' => TRUE, 'codigo' => 0, 'message' => '', 'data' => 'User not found. For more information contact us at info@fogatagroup.com.<br><br><i>Usuario no encontrado, escriba a info@fogatagroup.com si cree que no debería ver este mensaje.</i>'], REST_Controller::HTTP_OK);

		}
	*/

}
